package org.greenstone.gsdl3.gs3build.database;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.io.InputStream;
import java.util.Properties;
import org.greenstone.gsdl3.util.GlobalProperties;

public class GS3SQLConnectionFactory
{

    public static Connection getConnection(String database)
    {
	try {	    
	    String server = GlobalProperties.getProperty("mysql.server", "localhost");
	    String port = GlobalProperties.getProperty("mysql.tcp.port", "3306");
	    String password = GlobalProperties.getProperty("mysql.gsdl3admin.password");
	    
	    Class.forName("com.mysql.jdbc.Driver").newInstance();
	    String connection_address = "jdbc:mysql://"+server+":"+port+"/"+database+"?user=gsdl3admin";
	    if (password != null && !password.equals("")) {
		connection_address += "&password="+password;
	    }
	    Connection connection = DriverManager.getConnection(connection_address);
	    return connection;
	}
	catch (SQLException sqlEx) {
	    System.out.println(sqlEx.toString());
	}
	catch (Exception ex) {
	    System.out.println(ex.toString());
	}
	return null;
    }
    
    public static SQLConnection getSQLConnection(String database)
    {
	Connection c = getConnection(database);
	if (c== null) {
	    return null;
	}
	return new SQLConnection(c, database);
    }

    
    public static GS3SQLConnection getGS3SQLConnection(String database)
    {
	Connection c = getConnection(database);
	if (c== null) {
	    return null;
	}
	return new GS3SQLConnection(c, database);
    }

    /* returns a Connection to the server, */
    public static Connection getConnection() 
    {
	return getConnection("test");
    }

    /* returns a Connection to the server, */
    public static SQLConnection getSQLConnection() 
    {
	return getSQLConnection("test");
    }

    public static GS3SQLConnection getGS3SQLConnection()
    { 
	return getGS3SQLConnection("test");
    }

    public static void main(String args[])
    { 
	GS3SQLConnection connection = getGS3SQLConnection();
	connection.initCollection("maya");
    }
}
